; notnextchar.lisp - like notnextchar.pl but different

; quicklisp and package boilerplate. or use ASDF directly
#-quicklisp
(let ((quicklisp-init (merge-pathnames "quicklisp/setup.lisp"
                                       (user-homedir-pathname))))
  (when (probe-file quicklisp-init)
    (load quicklisp-init)))
(ql:quickload :cl-ppcre :silent t)
(defpackage :retest (:use :cl :cl-ppcre))
(in-package :retest)

; the regular expressions to compare
(defparameter *relist* '("^(.+)b" "^(.+?)b" "^([^b]+)"))

(defun mkstring (len)
  (let ((str (make-array 0 :element-type 'character
                         :adjustable t :fill-pointer 0)))
    (loop repeat len do (vector-push-extend #\a str))
    (concatenate 'string str "but not these bytes")))

(defmacro match (regex string)
  `(register-groups-bind (first) (,regex ,string :sharedp t) first))
(defmacro runre ((relist re string source) &body body)
  `(let ((,string ,source))
     (dolist (,re ,relist) ,@body)))

; what do the expressions match for a short test string?
(runre (*relist* expr string (mkstring 4))
       (format t "~&~10a|~a|~&" expr (match expr string)))

; and a microbenchmark on a longer string
(runre (*relist* expr string (mkstring 9999))
       (format t "~&~a~&" expr)
       (time (loop repeat 1000000 do (match expr string))))